const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const attendance_records = sequelize.define(
    'attendance_records',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

attendance_status: {
        type: DataTypes.ENUM,
      
      

        values: [

"present",


"absent",


"late",


"excused"

        ],

      },

minutes_late: {
        type: DataTypes.INTEGER,
      
      

      },

comment: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  attendance_records.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity































//end loop



    db.attendance_records.belongsTo(db.attendance_sessions, {
      as: 'attendance_session',
      foreignKey: {
        name: 'attendance_sessionId',
      },
      constraints: false,
    });

    db.attendance_records.belongsTo(db.students, {
      as: 'student',
      foreignKey: {
        name: 'studentId',
      },
      constraints: false,
    });




    db.attendance_records.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.attendance_records.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return attendance_records;
};


